#include <gccore.h>


/****************************************************************************
* CvtRGB
*
* This function simply returns two RGB pixels as one Y1CbY2Cr.
  Thanks to: http://tehwii.tehskeen.com/tehwii/examples.php !!!
*****************************************************************************/
u32 CvtRGB (u8 r1, u8 g1, u8 b1, u8 r2, u8 g2, u8 b2)
{
  int y1, cb1, cr1, y2, cb2, cr2, cb, cr ;

  y1 = (299 * r1 + 587 * g1 + 114 * b1) / 1000 ;
  cb1 = (-16874 * r1 - 33126 * g1 + 50000 * b1 + 12800000) / 100000 ;
  cr1 = (50000 * r1 - 41869 * g1 - 8131 * b1 + 12800000) / 100000 ;

  y2 = (299 * r2 + 587 * g2 + 114 * b2) / 1000 ;
  cb2 = (-16874 * r2 - 33126 * g2 + 50000 * b2 + 12800000) / 100000 ;
  cr2 = (50000 * r2 - 41869 * g2 - 8131 * b2 + 12800000) / 100000 ;

  cb = (cb1 + cb2) >> 1 ;
  cr = (cr1 + cr2) >> 1 ;

  return ((y1 << 24) | (cb << 16) | (y2 << 8) | cr) ;
}
